/* dma.h DMA header
 *
 * 
 * 2001 Camilo Alejandro Arboleda
 *
 */

#ifndef __DMA_H
#define __DMA_H

#define DMA_MEMBASE    0x68000u  /* This memory was freed by GRUB after booting
                                  * booting RTEMS image
                                  */
#define DMA_BUFSIZE    0x10000u

#define DMA_ADDR       0x004	/* port for low 16 bits of DMA address */
#define DMA_TOP        0x081	/* port for top 4 bits of 20-bit DMA addr */
#define DMA_COUNT      0x005	/* port for DMA count (count =  bytes - 1) */
#define DMA_FLIPFLOP   0x00C	/* DMA byte pointer flip-flop */
#define DMA_MODE       0x00B	/* DMA mode port */
#define DMA_INIT       0x00A	/* DMA init port */
#define DMA_MASK       0x00F	/* DMA init port */

rtems_device_driver dma_initialize(rtems_device_major_number major,
                                   rtems_device_minor_number minor,
                                   void                      *arg);

/* Entry points to this driver. */
#define DMA_DRIVER_TABLE_ENTRY { \
  dma_initialize,             \
  NULL,                       \
  NULL,                       \
  NULL,                       \
  NULL,                       \
  NULL                        \
}

#endif
