/*
 *  Simple test program -- simplified version of sample test hello.
 */

#define TEST_INIT

#include <bsp.h>
#include <irq.h>
#include <rtems/libio.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <rtems.h>
#include "dma.h"
#include "floppy.h"
#include <console.h>
#include <clockdrv.h>
#include <timerdrv.h>

/* extern void fdc_out(unsigned char val); */

extern char f_results[];/* the controller can give lots of output */
extern rtems_irq_connect_data floppy_isr_data;

rtems_task Init(
  rtems_task_argument ignored
)
{
   int fd;
   rtems_status_code status;
   unsigned char buffer[512];

   printf( "\n\n*** Disk Test ***\n" );

   /* Create motor off timer */

   printf("Task sleeping\n");
   status = rtems_task_wake_after( TIMEOUT << 4);

   printf("Disk sense\n");
   fd = open("/dev/fd0",O_RDWR,0);
   lseek(fd,0,SEEK_SET);
   read(fd,buffer,512);

   printf("Buffer Address %d\n",buffer);
   printf("%02x %02x %02x\n",buffer[0],buffer[1],buffer[2]);
   printf("%02x %02x %02x %02x %02x %02x %02x %02x\n",
	  buffer[3],buffer[4],buffer[5],buffer[6],buffer[7],
	  buffer[8],buffer[9],buffer[10]);
   printf("%02x %02x\n",buffer[11],buffer[12]);
   printf("%02x\n",buffer[13]);
   printf("%02x %02x\n",buffer[14],buffer[15]);
   printf("%02x\n",buffer[16]);
   printf("%02x %02x\n",buffer[17],buffer[18]);
   printf("%02x %02x\n",buffer[19],buffer[20]);
   printf("%02x\n",buffer[21]);
   printf("%02x %02x\n",buffer[22],buffer[23]);
   printf("%02x %02x\n",buffer[24],buffer[25]);
   printf("%02x %02x\n",buffer[26],buffer[27]);
   printf("%02x %02x\n",buffer[28],buffer[29]);

   printf( "*** End of Disk Test ***\n" );
   exit( 0 );
}

/* configuration information */

#define CONFIGURE_HAS_OWN_DEVICE_DRIVER_TABLE
/* #define CONFIGURE_APPLICATION_NEEDS_TIMER_DRIVER */
#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
#define CONFIGURE_INIT

#define CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS 20
#define CONFIGURE_MAXIMUM_TASKS                  10
#define CONFIGURE_MAXIMUM_DEVICES                50
#define CONFIGURE_MAXIMUM_TIMERS                 10

rtems_driver_address_table Device_drivers[] = {
   CONSOLE_DRIVER_TABLE_ENTRY,
   DMA_DRIVER_TABLE_ENTRY,
   CLOCK_DRIVER_TABLE_ENTRY,
   FLOPPY_DRIVER_TABLE_ENTRY,
   { NULL, NULL, NULL, NULL, NULL, NULL }
};

#include <confdefs.h>

/* end of file */
